﻿using System;
using System.Linq;
using System.Threading;

class Program {

    ThreadSafeQueue<int> queue = new ThreadSafeQueue<int>();

    public void Run(int threadCount, int threadWork) {

        Thread[] threads = new Thread[threadCount];

        for (int i = 0; i < threadCount; ++i) {
            threads[i] = new Thread(() => {
                for (int k = 0; k < threadWork; ++k) {
                    queue.Enqueue(1234);
                    queue.Dequeue();
                }
            });
            threads[i].Start();
        }

        for (int i = 0; i < threadCount; ++i) {
            threads[i].Join();
        }
    }

    static void Main(string[] args) {
        if (args.Length != 2) {
            Console.WriteLine("Usage: <# threads> <# push/pop iterations>");

        } else {
            var threadCount = int.Parse(args[0]);
            var threadWork = int.Parse(args[1]);

            Console.WriteLine("ThreadSafeQueue threads:{0}  work:{1}", threadCount, threadWork);

            new Program().Run(threadCount, threadWork);
        }
    }

} // class
