﻿using System.Collections.Generic;

class ThreadSafeQueue<T> {

    object theLock = new object();
    Queue<T> queue = new Queue<T>();

    public void Enqueue(T value) {
        lock (theLock) {
            queue.Enqueue(value);
        }
    }

    public T Dequeue() {
        lock (theLock) {
            return queue.Dequeue();
        }
    }

} // class
