﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

class ProcessUtil {

    public static int StartAndWaitForResult(string fileName, string arguments, out string stdOut, out string stdErr) {
        ProcessStartInfo info = new ProcessStartInfo(fileName, arguments);
        info.UseShellExecute = false;
        info.ErrorDialog = false;
        info.CreateNoWindow = true;
        info.RedirectStandardOutput = true;
        info.RedirectStandardError = true;

        stdOut = string.Empty;
        stdErr = string.Empty;

        StringBuilder o = new StringBuilder();
        StringBuilder err = new StringBuilder();

        using (Process p = Process.Start(info)) {

            p.OutputDataReceived += delegate(object sender, DataReceivedEventArgs e) {
                if (e.Data != null) {
                    o.AppendLine(e.Data);
                    Console.Write(".");
                }
            };

            p.ErrorDataReceived += delegate(object sender, DataReceivedEventArgs e) {
                if (e.Data != null) {
                    err.AppendLine(e.Data);
                    Console.Write("!");
                }
            };

            p.BeginErrorReadLine();
            p.BeginOutputReadLine();

            p.WaitForExit();

            Console.WriteLine();

            stdOut = o.ToString();
            stdErr = err.ToString();

            return p.ExitCode;
        }
    }

} // class
